// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "Components/ActorComponent.h"
#include "CoreMinimal.h"
#include <HsFFI.h>
#include <Therac.h>
#include <Internationalization/Text.h>
#include "TheracAdapterComponent.generated.h"

UCLASS(
    BlueprintType,
    ClassGroup = (Custom),
    meta       = (BlueprintSpawnableComponent)
)
class HSTHERAC25_API UTheracAdapterComponent : public UActorComponent {

  GENERATED_BODY()

  HsStablePtr wrappedComms;

  TMap<FText *, StateInfoRequest> compMap;

public:
  // Sets default values for this component's properties
  UTheracAdapterComponent();

  UPROPERTY(BlueprintReadOnly, VisibleAnywhere)
  FText TreatmentOutcome;

  UPROPERTY(BlueprintReadOnly, VisibleAnywhere)
  FText ActiveSubsystem;

  // TPhase
  UPROPERTY(BlueprintReadOnly, VisibleAnywhere)
  FText TreatmentState;

  // TreatmentOutcome
  UPROPERTY(BlueprintReadOnly, VisibleAnywhere)
  FText Reason;

  UPROPERTY(BlueprintReadOnly, VisibleAnywhere)
  FText BeamMode;

  UPROPERTY(BlueprintReadOnly, VisibleAnywhere)
  FText BeamEnergy;

protected:
  // Called when the game starts
  virtual void BeginPlay() override;

public:
  // Called every frame
  virtual void TickComponent(
      float DeltaTime,
      ELevelTick TickType,
      FActorComponentTickFunction * ThisTickFunction
  ) override;
};
